/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*
 * Generated by the ICS builderXcessory (BX).
 *
 *
 * Builder Xcessory 3.0 FT.
 *
 */
/*
 * MOTIF include files needed for widget creation.
 */
#include <Xm/Xm.h>
#include <Xm/TextF.h>
#include <Xm/CascadeB.h>
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>
#include <Xm/Label.h>
#include <Xm/Scale.h>
#include <Xm/MainW.h>
#include <Xm/BulletinB.h>
#include <Xm/RowColumn.h>
#include <Xm/MenuShell.h>

#include <vl/vl.h>   

#define DECLARE_BX_GLOBALS

/*
 * Global declarations are now stored in the header file 'creation.h'.
 *
 * If DECLARE_BX_GLOBALS is defined then this header file
 * declares the globals, otherwise it just externs them.
 */

#include "creation.h"

extern float Version_number;
extern VLServer vlSvr;  /* for widgets that GetControl upon creation */
extern VLPath   vlPath;
/*
 * Function: BxRegisterConverters()
 *     Registers all the converters for all widgets.
 */
static void
BxRegisterConverters()
{
    XtInitializeWidgetClass(xmTextFieldWidgetClass);
    XtInitializeWidgetClass(xmCascadeButtonWidgetClass);
    XtInitializeWidgetClass(xmPushButtonWidgetClass);
    XtInitializeWidgetClass(xmToggleButtonWidgetClass);
    XtInitializeWidgetClass(xmLabelWidgetClass);
    XtInitializeWidgetClass(xmScaleWidgetClass);
    XtInitializeWidgetClass(xmMainWindowWidgetClass);
    XtInitializeWidgetClass(xmBulletinBoardWidgetClass);
    XtInitializeWidgetClass(xmRowColumnWidgetClass);
    XtInitializeWidgetClass(topLevelShellWidgetClass);
    XtInitializeWidgetClass(xmMenuShellWidgetClass);
}

/*
 * Function prototypes for convenience routines
 * located in utilities file.
 */

#ifndef IGNORE_XPM_PIXMAP
extern XPM_PIXMAP();
#endif /* IGNORE_XPM_PIXMAP */

#ifndef IGNORE_MENU_POST
extern void MENU_POST();
#endif /* IGNORE_MENU_POST */

#ifndef IGNORE_CONVERT
extern XtPointer CONVERT();
#endif /* IGNORE_CONVERT */

/*
 * Function: CreatechromaShell()
 */
Widget
CreatechromaShell( parent)
Widget parent;
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    Widget 	retval;
    Widget	chromaShell;

    XtInitializeWidgetClass(topLevelShellWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNkeyboardFocusPolicy, XmPOINTER); argcnt++;
    XtSetArg(args[argcnt], XmNx, 747); argcnt++;
    XtSetArg(args[argcnt], XmNy, 703); argcnt++;
    chromaShell =  XtCreatePopupShell( "chromactlShell", 
        topLevelShellWidgetClass, parent, args, argcnt);
    retval = chromaShell;
}

/*
 * Function: CreatelumaShell()
 */
Widget
CreatelumaShell( parent)
Widget parent;
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    Widget 	retval;
    Widget	lumaShell;

    XtInitializeWidgetClass(topLevelShellWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNkeyboardFocusPolicy, XmPOINTER); argcnt++;
    XtSetArg(args[argcnt], XmNx, 1015); argcnt++;
    XtSetArg(args[argcnt], XmNy, 702); argcnt++;
    lumaShell =  XtCreatePopupShell( "lumactlShell", 
        topLevelShellWidgetClass, parent, args, argcnt);
    retval = lumaShell;
}
/*
 * Function: CreateswitchShell()
 */
Widget
CreateswitchShell( parent)
Widget parent;
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    Widget 	retval;
    Widget	switchShell;

    XtInitializeWidgetClass(topLevelShellWidgetClass);
    argcnt = 0;
    XtSetArg(args[argcnt], XmNkeyboardFocusPolicy, XmPOINTER); argcnt++;
    XtSetArg(args[argcnt], XmNx, 993); argcnt++;
    XtSetArg(args[argcnt], XmNy, 447); argcnt++;
    switchShell =  XtCreatePopupShell( "switchShell", 
        topLevelShellWidgetClass, parent, args, argcnt);
    retval = switchShell;
}


/*
 * Function: CreatemainWindow()
 *        Create mainWindow hierarchy of widgets.
 */
Widget
CreatemainWindow( parent)
Widget parent;
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    Widget 	retval;
    Widget	mainWindow;
    Widget	menuBar;
    Widget	fileCButton;
    Widget	menuShell;
    Widget	pulldownMenu;
    Widget	quitPB;
    Widget	optionsCButton;
    Widget	menuShell1;
    Widget	pulldownMenu2;
    Widget	option1PB;
    Widget	appsCButton;
    Widget	menuShell2;
    Widget	pulldownMenu4;
    Widget	app1PB;
    Widget	app2PB;
    Widget	app3PB;
    Widget	app4PB;
    Widget	app5PB;
    Widget	app6PB;
    Widget	utilitiesCascadeButton;
    Widget	menuShell3;
    Widget	pulldownMenu1;
    Widget	util1PB;
    Widget	util2PB;
    Widget	helpCButton;
    Widget	menuShell4;
    Widget	pulldownMenu3;
    Widget	helpPB;
    Widget	bulletinBoard;
    Widget	grabnsavePB;
    Widget	grabndispPB;
    Widget	vidovergfxPB;
    Widget	gfxovervidPB;
    Widget	fullscreenoutPB;

    argok = False;

    BxRegisterConverters();

    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 450); argcnt++;
    XtSetArg(args[argcnt], XmNy, 487); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 360); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 120); argcnt++;
    mainWindow = XtCreateWidget("mainWindow",
		xmMainWindowWidgetClass,
		parent,
		args,
		argcnt);
    retval = mainWindow;

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_BAR); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 415); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 24); argcnt++;
    menuBar = XtCreateWidget("menuBar",
		xmRowColumnWidgetClass,
		mainWindow,
		args,
		argcnt);
    XtManageChild(menuBar);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 5); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 37); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    fileCButton = XtCreateWidget("fileCButton",
		xmCascadeButtonWidgetClass,
		menuBar,
		args,
		argcnt);

    XtManageChild(fileCButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
    menuShell = XtCreatePopupShell("menuShell",
		xmMenuShellWidgetClass,
		XtParent(fileCButton),
		args,
		argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    XtSetArg(args[argcnt], XmNx, 456); argcnt++;
    XtSetArg(args[argcnt], XmNy, 511); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 54); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    pulldownMenu = XtCreateWidget("pulldownMenu",
		xmRowColumnWidgetClass,
		menuShell,
		args,
		argcnt);

    argcnt = 0;
    quitPB = XtCreateWidget("quitPB",
		xmPushButtonWidgetClass,
		pulldownMenu,
		args,
		argcnt);

    XtAddCallback(quitPB, XmNactivateCallback, quitPBHandler, (XtPointer)0);
    XtManageChild(quitPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldownMenu); argcnt++;
    XtSetValues(fileCButton, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 49); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 62); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    optionsCButton = XtCreateWidget("optionsCButton",
		xmCascadeButtonWidgetClass,
		menuBar,
		args,
		argcnt);

    XtManageChild(optionsCButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
    menuShell1 = XtCreatePopupShell("menuShell1",
		xmMenuShellWidgetClass,
		XtParent(optionsCButton),
		args,
		argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    XtSetArg(args[argcnt], XmNx, 500); argcnt++;
    XtSetArg(args[argcnt], XmNy, 511); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 149); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    pulldownMenu2 = XtCreateWidget("pulldownMenu2",
		xmRowColumnWidgetClass,
		menuShell1,
		args,
		argcnt);

    argcnt = 0;
    option1PB = XtCreateWidget("option1PB",
		xmPushButtonWidgetClass,
		pulldownMenu2,
		args,
		argcnt);

    XtAddCallback(option1PB, XmNactivateCallback, option1PBHandler, (XtPointer)0);
    XtManageChild(option1PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldownMenu2); argcnt++;
    XtSetValues(optionsCButton, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNlabelString, 
             CONVERT(parent,"Apps", "XmString", 0, &argok)); if (argok) argcnt++;
    XtSetArg(args[argcnt], XmNx, 118); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 47); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    appsCButton = XtCreateWidget("appsCButton",
		xmCascadeButtonWidgetClass,
		menuBar,
		args,
		argcnt);

    XtManageChild(appsCButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
    menuShell2 = XtCreatePopupShell("menuShell2",
		xmMenuShellWidgetClass,
		XtParent(appsCButton),
		args,
		argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    XtSetArg(args[argcnt], XmNx, 569); argcnt++;
    XtSetArg(args[argcnt], XmNy, 511); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 119); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 148); argcnt++;
    pulldownMenu4 = XtCreateWidget("pulldownMenu4",
		xmRowColumnWidgetClass,
		menuShell2,
		args,
		argcnt);

    argcnt = 0;
    app1PB = XtCreateWidget("app1PB",
		xmPushButtonWidgetClass,
		pulldownMenu4,
		args,
		argcnt);

    XtAddCallback(app1PB, XmNactivateCallback, app1PBHandler, (XtPointer)0);
    XtManageChild(app1PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    app2PB = XtCreateWidget("app2PB",
		xmPushButtonWidgetClass,
		pulldownMenu4,
		args,
		argcnt);

    XtAddCallback(app2PB, XmNactivateCallback, app2PBHandler, (XtPointer)0);
    XtManageChild(app2PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    app3PB = XtCreateWidget("app3PB",
		xmPushButtonWidgetClass,
		pulldownMenu4,
		args,
		argcnt);

    XtAddCallback(app3PB, XmNactivateCallback, app3PBHandler, (XtPointer)0);
    XtManageChild(app3PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    app4PB = XtCreateWidget("app4PB",
		xmPushButtonWidgetClass,
		pulldownMenu4,
		args,
		argcnt);

    XtAddCallback(app4PB, XmNactivateCallback, app4PBHandler, (XtPointer)0);
    XtManageChild(app4PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    app5PB = XtCreateWidget("app5PB",
		xmPushButtonWidgetClass,
		pulldownMenu4,
		args,
		argcnt);

    XtAddCallback(app5PB, XmNactivateCallback, app5PBHandler, (XtPointer)0);
    XtManageChild(app5PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    app6PB = XtCreateWidget("app6PB",
		xmPushButtonWidgetClass,
		pulldownMenu4,
		args,
		argcnt);

    XtAddCallback(app6PB, XmNactivateCallback, app6PBHandler, (XtPointer)0);
    XtManageChild(app6PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldownMenu4); argcnt++;
    XtSetValues(appsCButton, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 172); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 61); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    utilitiesCascadeButton = XtCreateWidget("utilitiesCascadeButton",
		xmCascadeButtonWidgetClass,
		menuBar,
		args,
		argcnt);

    XtManageChild(utilitiesCascadeButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
    menuShell3 = XtCreatePopupShell("menuShell3",
		xmMenuShellWidgetClass,
		XtParent(utilitiesCascadeButton),
		args,
		argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    XtSetArg(args[argcnt], XmNx, 623); argcnt++;
    XtSetArg(args[argcnt], XmNy, 511); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 143); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    pulldownMenu1 = XtCreateWidget("pulldownMenu1",
		xmRowColumnWidgetClass,
		menuShell3,
		args,
		argcnt);

    argcnt = 0;
    util1PB = XtCreateWidget("util1PB",
		xmPushButtonWidgetClass,
		pulldownMenu1,
		args,
		argcnt);

    XtAddCallback(util1PB, XmNactivateCallback, util1PBHandler, (XtPointer)0);
    XtManageChild(util1PB);

    argcnt = 0;
    util2PB = XtCreateWidget("util2PB",
		xmPushButtonWidgetClass,
		pulldownMenu1,
		args,
		argcnt);

    XtAddCallback(util2PB, XmNactivateCallback, util2PBHandler, (XtPointer)0);
    XtManageChild(util2PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldownMenu1); argcnt++;
    XtSetValues(utilitiesCascadeButton, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNx, 240); argcnt++;
    XtSetArg(args[argcnt], XmNy, 2); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 44); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    helpCButton = XtCreateWidget("helpCButton",
		xmCascadeButtonWidgetClass,
		menuBar,
		args,
		argcnt);

    XtManageChild(helpCButton);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNwidth, 1); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 1); argcnt++;
    menuShell4 = XtCreatePopupShell("menuShell4",
		xmMenuShellWidgetClass,
		XtParent(helpCButton),
		args,
		argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrowColumnType, XmMENU_PULLDOWN); argcnt++;
    XtSetArg(args[argcnt], XmNx, 691); argcnt++;
    XtSetArg(args[argcnt], XmNy, 511); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 180); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    pulldownMenu3 = XtCreateWidget("pulldownMenu3",
		xmRowColumnWidgetClass,
		menuShell4,
		args,
		argcnt);

    argcnt = 0;
    helpPB = XtCreateWidget("helpPB",
		xmPushButtonWidgetClass,
		pulldownMenu3,
		args,
		argcnt);

    XtAddCallback(helpPB, XmNactivateCallback, helpPBHandler, (XtPointer)0);
    XtManageChild(helpPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNsubMenuId, pulldownMenu3); argcnt++;
    XtSetValues(helpCButton, args, argcnt);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 360); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 120); argcnt++;
    bulletinBoard = XtCreateWidget("bulletinBoard",
		xmBulletinBoardWidgetClass,
		mainWindow,
		args,
		argcnt);
    XtManageChild(bulletinBoard);
 
/* we're not going to use this fullscreen out button for now
 *    argcnt = 0;
 *    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
 *    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
 *    XtSetArg(args[argcnt], XmNx, 10); argcnt++;
 *    XtSetArg(args[argcnt], XmNy, 80); argcnt++;
 *    XtSetArg(args[argcnt], XmNwidth, 110); argcnt++;
 *    XtSetArg(args[argcnt], XmNheight, 25); argcnt++;
 *    fullscreenoutPB = XtCreateWidget("fullscreenoutPB",
 *		xmPushButtonWidgetClass,
 *		bulletinBoard,
 *		args,
 *		argcnt);
 *    XtAddCallback(fullscreenoutPB, XmNactivateCallback, fullscreenoutPBHandler, (XtPointer)0);
 *    XtManageChild(fullscreenoutPB);
 */

/* the following two buttons only for all-VL version */
if (Version_number != 1){
    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 130); argcnt++;
    XtSetArg(args[argcnt], XmNy, 50); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 110); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 25); argcnt++;
    gfxovervidPB = XtCreateWidget("gfxovervidPB",
		xmPushButtonWidgetClass,
		bulletinBoard,
		args,
		argcnt);

    XtAddCallback(gfxovervidPB, XmNactivateCallback, gfxovervidPBHandler, (XtPointer)0);
    XtManageChild(gfxovervidPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 10); argcnt++;
    XtSetArg(args[argcnt], XmNy, 50); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 110); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 25); argcnt++;
    vidovergfxPB = XtCreateWidget("vidovergfxPB",
		xmPushButtonWidgetClass,
		bulletinBoard,
		args,
		argcnt);

    XtAddCallback(vidovergfxPB, XmNactivateCallback, vidovergfxPBHandler, (XtPointer)0);
    XtManageChild(vidovergfxPB);

} /* end if Version_number not equal to 1 */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 130); argcnt++;
    XtSetArg(args[argcnt], XmNy, 20); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 110); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 25); argcnt++;
    grabndispPB = XtCreateWidget("grabndispPB",
		xmPushButtonWidgetClass,
		bulletinBoard,
		args,
		argcnt);

    XtAddCallback(grabndispPB, XmNactivateCallback, grabndispPBHandler, (XtPointer)0);
    XtManageChild(grabndispPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 10); argcnt++;
    XtSetArg(args[argcnt], XmNy, 20); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 110); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 25); argcnt++;
    grabnsavePB = XtCreateWidget("grabnsavePB",
		xmPushButtonWidgetClass,
		bulletinBoard,
		args,
		argcnt);

    XtAddCallback(grabnsavePB, XmNactivateCallback, grabnsavePBHandler, (XtPointer)0);
    XtManageChild(grabnsavePB);

    return( retval );
}

/*
 * Function: CreatechromaBBoard()
 *        Create chromaBBoard hierarchy of widgets.
 */
Widget
CreatechromaBBoard( parent)
Widget parent;
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    char	text[50];
    VLControlValue vlgotval;
    int		scalevals[5];
    int		umin,umax,vmin,vmax;
    Widget 	retval;
    Widget	chromaBBoard;
    Widget	uminTF; 
    Widget	umaxTF; 
    Widget	vminTF;
    Widget	vmaxTF;
    Widget	chromasharpTF;
    Widget	uminScale;
    Widget	umaxScale;
    Widget	urangelockTB;
    Widget	vminScale;
    Widget	vmaxScale;
    Widget	vrangelockTB;
    Widget	chromasharpScale;
    Widget	uminLabel;
    Widget	umaxLabel;
    Widget	vminLabel;
    Widget	vmaxLabel;
    Widget	chromasharpLabel;
    Widget	chromasetTB;
    Widget	chromaDoPB;
    Widget	chromaAPB;
    Widget	chromaBPB;
    Widget	chroma1PB;
    Widget	chroma2PB;
    Widget	chroma3PB;
    Widget	chroma4PB;

    argok = False;

    BxRegisterConverters();

    /* get values for the sliders from current VL state */
    getAllChromaVLValues(&scalevals);
    rangevaltominmax(scalevals[0],scalevals[1],&umin,&umax);
    rangevaltominmax(scalevals[2],scalevals[3],&vmin,&vmax);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    XtSetArg(args[argcnt], XmNx, 747); argcnt++;
    XtSetArg(args[argcnt], XmNy, 703); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 249); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 310); argcnt++;
    chromaBBoard = XtCreateWidget("chromaBBoard",
		xmBulletinBoardWidgetClass,
		parent,
		args,
		argcnt);
    XtAddCallback(chromaBBoard, XmNdestroyCallback, chromaBBdestroyHandler,
		  (XtPointer)0);
    retval = chromaBBoard;

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 170); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 20); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    chroma4PB = XtCreateWidget("chroma4PB",
		xmPushButtonWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(chroma4PB, XmNactivateCallback, chroma4PBHandler, (XtPointer)0);
    XtManageChild(chroma4PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 150); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 20); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    chroma3PB = XtCreateWidget("chroma3PB",
		xmPushButtonWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(chroma3PB, XmNactivateCallback, chroma3PBHandler, (XtPointer)0);
    XtManageChild(chroma3PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 130); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 20); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    chroma2PB = XtCreateWidget("chroma2PB",
		xmPushButtonWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(chroma2PB, XmNactivateCallback, chroma2PBHandler, (XtPointer)0);
    XtManageChild(chroma2PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 110); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 20); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    chroma1PB = XtCreateWidget("chroma1PB",
		xmPushButtonWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(chroma1PB, XmNactivateCallback, chroma1PBHandler, (XtPointer)0);
    XtManageChild(chroma1PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 90); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 20); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    chromaBPB = XtCreateWidget("chromaBPB",
		xmPushButtonWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(chromaBPB, XmNactivateCallback, chromaBPBHandler, (XtPointer)0);
    XtManageChild(chromaBPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 70); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 20); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    chromaAPB = XtCreateWidget("chromaAPB",
		xmPushButtonWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(chromaAPB, XmNactivateCallback, chromaAPBHandler, (XtPointer)0);
    XtManageChild(chromaAPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 20); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    chromaDoPB = XtCreateWidget("chromaDoPB",
		xmPushButtonWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(chromaDoPB, XmNactivateCallback, chromaDoPBHandler, (XtPointer)0);
    XtManageChild(chromaDoPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 190); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 50); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    chromasetTB = XtCreateWidget("chromasetTB",
		xmToggleButtonWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(chromasetTB, XmNvalueChangedCallback, chromasetTBHandler, (XtPointer)0);
    XtManageChild(chromasetTB);
    ChromasetTB = chromasetTB; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 180); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    chromasharpLabel = XtCreateWidget("chromasharpLabel",
		xmLabelWidgetClass,
		chromaBBoard,
		args,
		argcnt);
    XtManageChild(chromasharpLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 140); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    vmaxLabel = XtCreateWidget("vmaxLabel",
		xmLabelWidgetClass,
		chromaBBoard,
		args,
		argcnt);
    XtManageChild(vmaxLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 100); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    vminLabel = XtCreateWidget("vminLabel",
		xmLabelWidgetClass,
		chromaBBoard,
		args,
		argcnt);
    XtManageChild(vminLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 60); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    umaxLabel = XtCreateWidget("umaxLabel",
		xmLabelWidgetClass,
		chromaBBoard,
		args,
		argcnt);
    XtManageChild(umaxLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 20); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    uminLabel = XtCreateWidget("uminLabel",
		xmLabelWidgetClass,
		chromaBBoard,
		args,
		argcnt);
    XtManageChild(uminLabel);


    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmVERTICAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, False); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 192); argcnt++;
    XtSetArg(args[argcnt], XmNy, 58); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 19); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 195); argcnt++;
    XtSetArg(args[argcnt], XmNminimum, -8); argcnt++;
    XtSetArg(args[argcnt], XmNmaximum, 7); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, scalevals[4]); argcnt++;
    chromasharpScale = XtCreateWidget("chromasharpScale",
		xmScaleWidgetClass,
		chromaBBoard,
		args,
		argcnt);
    XtAddCallback(chromasharpScale, XmNdragCallback, chromasharpScaleHandler, (XtPointer)0);
    XtAddCallback(chromasharpScale, XmNvalueChangedCallback, chromasharpScaleHandler, (XtPointer)0);
    XtManageChild(chromasharpScale);
    ChromasharpScale = chromasharpScale; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmVERTICAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, False); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 152); argcnt++;
    XtSetArg(args[argcnt], XmNy, 58); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 19); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 195); argcnt++;
    XtSetArg(args[argcnt], XmNminimum, -179); argcnt++;
    XtSetArg(args[argcnt], XmNmaximum, 179); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, vmax); argcnt++;
    vmaxScale = XtCreateWidget("vmaxScale",
		xmScaleWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(vmaxScale, XmNdragCallback, vmaxScaleHandler, (XtPointer)0);
    XtAddCallback(vmaxScale, XmNvalueChangedCallback, vmaxScaleHandler, (XtPointer)0);
    XtManageChild(vmaxScale);
    VmaxScale = vmaxScale; /* set global */


    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmVERTICAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, False); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 112); argcnt++;
    XtSetArg(args[argcnt], XmNy, 58); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 19); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 195); argcnt++;
    XtSetArg(args[argcnt], XmNminimum, -179); argcnt++;
    XtSetArg(args[argcnt], XmNmaximum, 179); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, vmin); argcnt++;
    vminScale = XtCreateWidget("vminScale",
		xmScaleWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(vminScale, XmNdragCallback, vminScaleHandler, (XtPointer)0);
    XtAddCallback(vminScale, XmNvalueChangedCallback, vminScaleHandler, (XtPointer)0);
    XtManageChild(vminScale);
    VminScale = vminScale;

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 115); argcnt++;
    XtSetArg(args[argcnt], XmNy, 250); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 50); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    vrangelockTB = XtCreateWidget("vrangelockTB",
		xmToggleButtonWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(vrangelockTB, XmNvalueChangedCallback, vrangelockTBHandler, (XtPointer)0);
    XtManageChild(vrangelockTB);
    VrangelockTB = vrangelockTB; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmVERTICAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, False); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 72); argcnt++;
    XtSetArg(args[argcnt], XmNy, 58); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 19); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 195); argcnt++;
    XtSetArg(args[argcnt], XmNminimum, -226); argcnt++;
    XtSetArg(args[argcnt], XmNmaximum, 226); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, umax); argcnt++;
    umaxScale = XtCreateWidget("umaxScale",
		xmScaleWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(umaxScale, XmNdragCallback, umaxScaleHandler, (XtPointer)0);
    XtAddCallback(umaxScale, XmNvalueChangedCallback, umaxScaleHandler, (XtPointer)0);
    XtManageChild(umaxScale);
    UmaxScale = umaxScale; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmVERTICAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, False); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 32); argcnt++;
    XtSetArg(args[argcnt], XmNy, 58); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 19); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 195); argcnt++;
    XtSetArg(args[argcnt], XmNminimum, -226); argcnt++;
    XtSetArg(args[argcnt], XmNmaximum, 226); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, umin); argcnt++;
    uminScale = XtCreateWidget("uminScale",
		xmScaleWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(uminScale, XmNdragCallback, uminScaleHandler, (XtPointer)0);
    XtAddCallback(uminScale, XmNvalueChangedCallback, uminScaleHandler, (XtPointer)0);
    XtManageChild(uminScale);
    UminScale = uminScale; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 35); argcnt++;
    XtSetArg(args[argcnt], XmNy, 250); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 50); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    urangelockTB = XtCreateWidget("urangelockTB",
		xmToggleButtonWidgetClass,
		chromaBBoard,
		args,
		argcnt);

    XtAddCallback(urangelockTB, XmNvalueChangedCallback, urangelockTBHandler, (XtPointer)0);
    XtManageChild(urangelockTB);
    UrangelockTB = urangelockTB; /* set global */


    argcnt = 0;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNcursorPositionVisible, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 180); argcnt++;
    XtSetArg(args[argcnt], XmNy, 28); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 1); argcnt++;
    sprintf(text, "%d", scalevals[4]); 
    XtSetArg(args[argcnt], XmNvalue, text); argcnt++;  
/*    XtSetArg(args[argcnt], XmNvalue, "0"); argcnt++;  */
    chromasharpTF = XtCreateWidget("chromasharpTF",
		xmTextFieldWidgetClass,
		chromaBBoard,
		args,
		argcnt);
    XtManageChild(chromasharpTF);
    ChromasharpTF = chromasharpTF; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNcursorPositionVisible, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 140); argcnt++;
    XtSetArg(args[argcnt], XmNy, 28); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 1); argcnt++;
    sprintf(text, "%d", vmax); 
    XtSetArg(args[argcnt], XmNvalue, text); argcnt++;  
/*    XtSetArg(args[argcnt], XmNvalue, "0"); argcnt++; */
    vmaxTF = XtCreateWidget("vmaxTF",
		xmTextFieldWidgetClass,
		chromaBBoard,
		args,
		argcnt);
    XtManageChild(vmaxTF);
    VmaxTF = vmaxTF; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNcursorPositionVisible, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 100); argcnt++;
    XtSetArg(args[argcnt], XmNy, 28); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 1); argcnt++;
    sprintf(text, "%d", vmin); 
    XtSetArg(args[argcnt], XmNvalue, text); argcnt++;  
/*    XtSetArg(args[argcnt], XmNvalue, "0"); argcnt++; */
    vminTF = XtCreateWidget("vminTF",
		xmTextFieldWidgetClass,
		chromaBBoard,
		args,
		argcnt);
    XtManageChild(vminTF);
    VminTF = vminTF; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, False); argcnt++;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNcursorPositionVisible, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 60); argcnt++;
    XtSetArg(args[argcnt], XmNy, 28); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 1); argcnt++;
    sprintf(text, "%d", umax); 
    XtSetArg(args[argcnt], XmNvalue, text); argcnt++;  
/*    XtSetArg(args[argcnt], XmNvalue, "0"); argcnt++; */
    umaxTF = XtCreateWidget("umaxTF",
		xmTextFieldWidgetClass,
		chromaBBoard,
		args,
		argcnt);
    XtManageChild(umaxTF);
    UmaxTF = umaxTF; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNcursorPositionVisible, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 20); argcnt++;
    XtSetArg(args[argcnt], XmNy, 28); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 1); argcnt++;
    sprintf(text, "%d", umin); 
    XtSetArg(args[argcnt], XmNvalue, text); argcnt++;  
/*    XtSetArg(args[argcnt], XmNvalue, "0"); argcnt++; */
    uminTF = XtCreateWidget("uminTF",
		xmTextFieldWidgetClass,
		chromaBBoard,
		args,
		argcnt);
    XtManageChild(uminTF);
    UminTF = uminTF; /* set global */

    return( retval );
}

/*
 * Function: CreatelumaBBoard()
 *        Create lumaBBoard hierarchy of widgets.
 */
Widget
CreatelumaBBoard( parent)
Widget parent;
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    char	text[50];
    int		scalevals[4];
    int		ymin,ymax;
    Widget 	retval;
    Widget	lumaBBoard;
    Widget	yminTF;
    Widget	ymaxTF;
    Widget	lumasharpTF;
    Widget	lumafgopTF;
    Widget	yminScale;
    Widget	ymaxScale;
    Widget	yrangelockTB;
    Widget	lumasharpScale;
    Widget	lumafgopScale;
    Widget	yminLabel;
    Widget	ymaxLabel;
    Widget	lumasharpLabel;
    Widget	lumafgopLabel;
    Widget	lumasetTB;
    Widget	lumaDoPB;
    Widget	lumaAPB;
    Widget	lumaBPB;
    Widget	luma1PB;
    Widget	luma2PB;
    Widget	luma3PB;
    Widget	luma4PB;

    argok = False;

    BxRegisterConverters();

    getAllLumaVLValues(&scalevals);
    rangevaltominmax(scalevals[0],scalevals[1],&ymin,&ymax);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    XtSetArg(args[argcnt], XmNx, 1015); argcnt++;
    XtSetArg(args[argcnt], XmNy, 702); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 251); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 310); argcnt++;
    lumaBBoard = XtCreateWidget("lumaBBoard",
		xmBulletinBoardWidgetClass,
		parent,
		args,
		argcnt);
    XtAddCallback(lumaBBoard, XmNdestroyCallback, lumaBBdestroyHandler,
		  (XtPointer)0);
    retval = lumaBBoard;

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 170); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 20); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    luma4PB = XtCreateWidget("luma4PB",
		xmPushButtonWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(luma4PB, XmNactivateCallback, luma4PBHandler, (XtPointer)0);
    XtManageChild(luma4PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 150); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 20); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    luma3PB = XtCreateWidget("luma3PB",
		xmPushButtonWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(luma3PB, XmNactivateCallback, luma3PBHandler, (XtPointer)0);
    XtManageChild(luma3PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 130); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 20); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    luma2PB = XtCreateWidget("luma2PB",
		xmPushButtonWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(luma2PB, XmNactivateCallback, luma2PBHandler, (XtPointer)0);
    XtManageChild(luma2PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 110); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 20); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    luma1PB = XtCreateWidget("luma1PB",
		xmPushButtonWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(luma1PB, XmNactivateCallback, luma1PBHandler, (XtPointer)0);
    XtManageChild(luma1PB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 90); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 20); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    lumaBPB = XtCreateWidget("lumaBPB",
		xmPushButtonWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(lumaBPB, XmNactivateCallback, lumaBPBHandler, (XtPointer)0);
    XtManageChild(lumaBPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 70); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 20); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    lumaAPB = XtCreateWidget("lumaAPB",
		xmPushButtonWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(lumaAPB, XmNactivateCallback, lumaAPBHandler, (XtPointer)0);
    XtManageChild(lumaAPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 20); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    lumaDoPB = XtCreateWidget("lumaDoPB",
		xmPushButtonWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(lumaDoPB, XmNactivateCallback, lumaDoHandler, (XtPointer)0);
    XtManageChild(lumaDoPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 190); argcnt++;
    XtSetArg(args[argcnt], XmNy, 280); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 50); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    lumasetTB = XtCreateWidget("lumasetTB",
		xmToggleButtonWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(lumasetTB, XmNvalueChangedCallback, lumasetTBHandler, (XtPointer)0);
    XtManageChild(lumasetTB);
    LumasetTB = lumasetTB; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 160); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    lumafgopLabel = XtCreateWidget("lumafgopLabel",
		xmLabelWidgetClass,
		lumaBBoard,
		args,
		argcnt);
    XtManageChild(lumafgopLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 120); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    lumasharpLabel = XtCreateWidget("lumasharpLabel",
		xmLabelWidgetClass,
		lumaBBoard,
		args,
		argcnt);
    XtManageChild(lumasharpLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 80); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    ymaxLabel = XtCreateWidget("ymaxLabel",
		xmLabelWidgetClass,
		lumaBBoard,
		args,
		argcnt);
    XtManageChild(ymaxLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 40); argcnt++;
    XtSetArg(args[argcnt], XmNy, 10); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 20); argcnt++;
    yminLabel = XtCreateWidget("yminLabel",
		xmLabelWidgetClass,
		lumaBBoard,
		args,
		argcnt);
    XtManageChild(yminLabel);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmVERTICAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, False); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 172); argcnt++;
    XtSetArg(args[argcnt], XmNy, 58); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 19); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 195); argcnt++;
    XtSetArg(args[argcnt], XmNminimum, 0); argcnt++;
    XtSetArg(args[argcnt], XmNmaximum, 255); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, scalevals[3]); argcnt++;  
    lumafgopScale = XtCreateWidget("lumafgopScale",
		xmScaleWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(lumafgopScale, XmNdragCallback, lumafgopScaleHandler, (XtPointer)0);
    XtAddCallback(lumafgopScale, XmNvalueChangedCallback, lumafgopScaleHandler, (XtPointer)0);
    XtManageChild(lumafgopScale);
    LumafgopScale = lumafgopScale; /* set global */


    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmVERTICAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, False); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 132); argcnt++;
    XtSetArg(args[argcnt], XmNy, 58); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 19); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 195); argcnt++;
    XtSetArg(args[argcnt], XmNminimum, -8); argcnt++;
    XtSetArg(args[argcnt], XmNmaximum, 7); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, scalevals[2]); argcnt++;  
    lumasharpScale = XtCreateWidget("lumasharpScale",
		xmScaleWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(lumasharpScale, XmNdragCallback, lumasharpScaleHandler, (XtPointer)0);
    XtAddCallback(lumasharpScale, XmNvalueChangedCallback, lumasharpScaleHandler, (XtPointer)0);
    XtManageChild(lumasharpScale);
    LumasharpScale = lumasharpScale; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmVERTICAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, False); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 92); argcnt++;
    XtSetArg(args[argcnt], XmNy, 58); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 19); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 195); argcnt++;
    XtSetArg(args[argcnt], XmNminimum, 0); argcnt++;
    XtSetArg(args[argcnt], XmNmaximum, 255); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, ymax); argcnt++;  
    ymaxScale = XtCreateWidget("ymaxScale",
		xmScaleWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(ymaxScale, XmNdragCallback, ymaxScaleHandler, (XtPointer)0);
    XtAddCallback(ymaxScale, XmNvalueChangedCallback, ymaxScaleHandler, (XtPointer)0);
    XtManageChild(ymaxScale);
    YmaxScale = ymaxScale; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmVERTICAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, False); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 52); argcnt++;
    XtSetArg(args[argcnt], XmNy, 58); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 19); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 195); argcnt++;
    XtSetArg(args[argcnt], XmNminimum, 0); argcnt++;
    XtSetArg(args[argcnt], XmNmaximum, 255); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, ymin); argcnt++;  
    yminScale = XtCreateWidget("yminScale",
		xmScaleWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(yminScale, XmNdragCallback, yminScaleHandler, (XtPointer)0);
    XtAddCallback(yminScale, XmNvalueChangedCallback, yminScaleHandler, (XtPointer)0);
    XtManageChild(yminScale);
    YminScale = yminScale; /* set global */


    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 55); argcnt++;
    XtSetArg(args[argcnt], XmNy, 250); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 50); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 30); argcnt++;
    yrangelockTB = XtCreateWidget("yrangelockTB",
		xmToggleButtonWidgetClass,
		lumaBBoard,
		args,
		argcnt);

    XtAddCallback(yrangelockTB, XmNvalueChangedCallback, yrangelockTBHandler, (XtPointer)0);
    XtManageChild(yrangelockTB);
    YrangelockTB = yrangelockTB; /* set global */


    argcnt = 0;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNcursorPositionVisible, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 160); argcnt++;
    XtSetArg(args[argcnt], XmNy, 28); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 1); argcnt++;
    sprintf(text, "%d", scalevals[3]); 
    XtSetArg(args[argcnt], XmNvalue, text); argcnt++;  
    lumafgopTF = XtCreateWidget("lumafgopTF",
		xmTextFieldWidgetClass,
		lumaBBoard,
		args,
		argcnt);
    XtManageChild(lumafgopTF);
    LumafgopTF = lumafgopTF; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNcursorPositionVisible, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 120); argcnt++;
    XtSetArg(args[argcnt], XmNy, 28); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 1); argcnt++;
    sprintf(text, "%d", scalevals[2]); 
    XtSetArg(args[argcnt], XmNvalue, text); argcnt++;  
    lumasharpTF = XtCreateWidget("lumasharpTF",
		xmTextFieldWidgetClass,
		lumaBBoard,
		args,
		argcnt);
    XtManageChild(lumasharpTF);
    LumasharpTF = lumasharpTF; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNcursorPositionVisible, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 80); argcnt++;
    XtSetArg(args[argcnt], XmNy, 28); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 1); argcnt++;
    sprintf(text, "%d", ymax); 
    XtSetArg(args[argcnt], XmNvalue, text); argcnt++;  
    ymaxTF = XtCreateWidget("ymaxTF",
		xmTextFieldWidgetClass,
		lumaBBoard,
		args,
		argcnt);
    XtManageChild(ymaxTF);
    YmaxTF = ymaxTF; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, False); argcnt++;
    XtSetArg(args[argcnt], XmNeditable, False); argcnt++;
    XtSetArg(args[argcnt], XmNcursorPositionVisible, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 40); argcnt++;
    XtSetArg(args[argcnt], XmNy, 28); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 28); argcnt++;
    XtSetArg(args[argcnt], XmNmarginWidth, 1); argcnt++;
    sprintf(text, "%d", ymin); 
    XtSetArg(args[argcnt], XmNvalue, text); argcnt++;  
    yminTF = XtCreateWidget("yminTF",
		xmTextFieldWidgetClass,
		lumaBBoard,
		args,
		argcnt);
    XtManageChild(yminTF);
    YminTF = yminTF; /* set global */

    return( retval );
}

/*
 * Function: CreateswitchBBoard()
 *        Create switchBBoard hierarchy of widgets.
 */
Widget
CreateswitchBBoard( parent)
Widget parent;
{
    Arg    	args[512];
    Cardinal   	argcnt;
    Boolean   	argok;
    Widget 	retval;
    Widget	switchBBoard;
    Widget	upperleftswitchPB;
    Widget	tilesswitchPB;
    Widget	leftrightswitchPB;
    Widget	elevatorhorizswitchPB;
    Widget	crossswitchPB;
    Widget	squaresswitchPB;
    Widget	rectoutswitchPB;
    Widget	fadeswitchPB;
    Widget	automanualTB;
    Widget	switchspeedScale;
    Widget	fuzzScale;
    Widget	manualScale;
    Widget	repeatScale;

    argok = False;

    BxRegisterConverters();

    argcnt = 0;
    XtSetArg(args[argcnt], XmNresizePolicy, XmRESIZE_GROW); argcnt++;
    XtSetArg(args[argcnt], XmNx, 894); argcnt++;
    XtSetArg(args[argcnt], XmNy, 447); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 360); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 310); argcnt++;
    switchBBoard = XtCreateWidget("switchBBoard",
		xmBulletinBoardWidgetClass,
		parent,
		args,
		argcnt);
    XtAddCallback(switchBBoard, XmNdestroyCallback, switchBBdestroyHandler,
		  (XtPointer)0);
    retval = switchBBoard;

    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmHORIZONTAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, True); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 210); argcnt++;
    XtSetArg(args[argcnt], XmNy, 220); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 104); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 58); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, 60); argcnt++;
    repeatScale = XtCreateWidget("repeatScale",
		xmScaleWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(repeatScale, XmNdragCallback, repeatScaleHandler, (XtPointer)0);
    XtAddCallback(repeatScale, XmNvalueChangedCallback, repeatScaleHandler, (XtPointer)0);
    XtManageChild(repeatScale);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmHORIZONTAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, True); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 210); argcnt++;
    XtSetArg(args[argcnt], XmNy, 150); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 140); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 59); argcnt++;
    manualScale = XtCreateWidget("manualScale",
		xmScaleWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(manualScale, XmNdragCallback, manualScaleHandler, (XtPointer)0);
    XtAddCallback(manualScale, XmNvalueChangedCallback, manualScaleHandler, (XtPointer)0);
    XtManageChild(manualScale);
    ManualScale = manualScale; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmHORIZONTAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, True); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 40); argcnt++;
    XtSetArg(args[argcnt], XmNy, 220); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 104); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 58); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, 100); argcnt++;
    fuzzScale = XtCreateWidget("fuzzScale",
		xmScaleWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(fuzzScale, XmNdragCallback, fuzzScaleHandler, (XtPointer)0);
    XtAddCallback(fuzzScale, XmNvalueChangedCallback, fuzzScaleHandler, (XtPointer)0);
    XtManageChild(fuzzScale);
    FuzzScale = fuzzScale; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNorientation, XmHORIZONTAL); argcnt++;
    XtSetArg(args[argcnt], XmNshowValue, True); argcnt++;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNx, 40); argcnt++;
    XtSetArg(args[argcnt], XmNy, 150); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 104); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 58); argcnt++;
    XtSetArg(args[argcnt], XmNvalue, 50); argcnt++;
    switchspeedScale = XtCreateWidget("switchspeedScale",
		xmScaleWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(switchspeedScale, XmNdragCallback, switchspeedScaleHandler, (XtPointer)0);
    XtManageChild(switchspeedScale);
    SwitchspeedScale = switchspeedScale; /* set global */

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 250); argcnt++;
    XtSetArg(args[argcnt], XmNy, 60); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 110); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 27); argcnt++;
    XtSetArg(args[argcnt], XmNset, True); argcnt++;
    automanualTB = XtCreateWidget("automanualTB",
		xmToggleButtonWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(automanualTB, XmNvalueChangedCallback, automanualTBHandler, (XtPointer)0);
    XtManageChild(automanualTB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelType, XmPIXMAP); argcnt++;
    XtSetArg(args[argcnt], XmNlabelPixmap, 
	XPM_PIXMAP(parent, fadeswitch)); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
             CONVERT(parent,"", "XmString", 0, &argok)); if (argok) argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 190); argcnt++;
    XtSetArg(args[argcnt], XmNy, 80); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 41); argcnt++;
    fadeswitchPB = XtCreateWidget("fadeswitchPB",
		xmPushButtonWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(fadeswitchPB, XmNactivateCallback, fadeswitchPBHandler, (XtPointer)0);
    XtManageChild(fadeswitchPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelType, XmPIXMAP); argcnt++;
    XtSetArg(args[argcnt], XmNlabelPixmap, 
	XPM_PIXMAP(parent, rectoutswitch)); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
             CONVERT(parent,"", "XmString", 0, &argok)); if (argok) argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 190); argcnt++;
    XtSetArg(args[argcnt], XmNy, 30); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 41); argcnt++;
    rectoutswitchPB = XtCreateWidget("rectoutswitchPB",
		xmPushButtonWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(rectoutswitchPB, XmNactivateCallback, rectoutswitchPBHandler, (XtPointer)0);
    XtManageChild(rectoutswitchPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelType, XmPIXMAP); argcnt++;
    XtSetArg(args[argcnt], XmNlabelPixmap, 
	XPM_PIXMAP(parent, squaresswitch)); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
             CONVERT(parent,"", "XmString", 0, &argok)); if (argok) argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 90); argcnt++;
    XtSetArg(args[argcnt], XmNy, 80); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 41); argcnt++;
    squaresswitchPB = XtCreateWidget("squaresswitchPB",
		xmPushButtonWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(squaresswitchPB, XmNactivateCallback, squaresswitchPBHandler, (XtPointer)0);
    XtManageChild(squaresswitchPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelType, XmPIXMAP); argcnt++;
    XtSetArg(args[argcnt], XmNlabelPixmap, 
	XPM_PIXMAP(parent, crossswitch)); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
             CONVERT(parent,"", "XmString", 0, &argok)); if (argok) argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 140); argcnt++;
    XtSetArg(args[argcnt], XmNy, 30); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 41); argcnt++;
    crossswitchPB = XtCreateWidget("crossswitchPB",
		xmPushButtonWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(crossswitchPB, XmNactivateCallback, crossswitchPBHandler, (XtPointer)0);
    XtManageChild(crossswitchPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelType, XmPIXMAP); argcnt++;
    XtSetArg(args[argcnt], XmNlabelPixmap, 
	XPM_PIXMAP(parent, elevatorhorizswitch)); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
             CONVERT(parent,"", "XmString", 0, &argok)); if (argok) argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 90); argcnt++;
    XtSetArg(args[argcnt], XmNy, 30); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 41); argcnt++;
    elevatorhorizswitchPB = XtCreateWidget("elevatorhorizswitchPB",
		xmPushButtonWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(elevatorhorizswitchPB, XmNactivateCallback, elevatorhorizswitchPBHandler, (XtPointer)0);
    XtManageChild(elevatorhorizswitchPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelType, XmPIXMAP); argcnt++;
    XtSetArg(args[argcnt], XmNlabelPixmap, 
	XPM_PIXMAP(parent, lrdiag1switch)); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
             CONVERT(parent,"", "XmString", 0, &argok)); if (argok) argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 40); argcnt++;
    XtSetArg(args[argcnt], XmNy, 30); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 41); argcnt++;
    leftrightswitchPB = XtCreateWidget("leftrightswitchPB",
		xmPushButtonWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(leftrightswitchPB, XmNactivateCallback, leftrightswitchPBHandler, (XtPointer)0);
    XtManageChild(leftrightswitchPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelType, XmPIXMAP); argcnt++;
    XtSetArg(args[argcnt], XmNlabelPixmap, 
	XPM_PIXMAP(parent, tilesswitch)); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
             CONVERT(parent,"", "XmString", 0, &argok)); if (argok) argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 140); argcnt++;
    XtSetArg(args[argcnt], XmNy, 80); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 41); argcnt++;
    tilesswitchPB = XtCreateWidget("tilesswitchPB",
		xmPushButtonWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(tilesswitchPB, XmNactivateCallback, tilesswitchPBHandler, (XtPointer)0);
    XtManageChild(tilesswitchPB);

    argcnt = 0;
    XtSetArg(args[argcnt], XmNhighlightOnEnter, True); argcnt++;
    XtSetArg(args[argcnt], XmNlabelType, XmPIXMAP); argcnt++;
    XtSetArg(args[argcnt], XmNlabelPixmap, 
	XPM_PIXMAP(parent, upperleftswitch)); argcnt++;
    XtSetArg(args[argcnt], XmNlabelString, 
             CONVERT(parent,"", "XmString", 0, &argok)); if (argok) argcnt++;
    XtSetArg(args[argcnt], XmNrecomputeSize, False); argcnt++;
    XtSetArg(args[argcnt], XmNx, 40); argcnt++;
    XtSetArg(args[argcnt], XmNy, 80); argcnt++;
    XtSetArg(args[argcnt], XmNwidth, 40); argcnt++;
    XtSetArg(args[argcnt], XmNheight, 41); argcnt++;
    upperleftswitchPB = XtCreateWidget("upperleftswitchPB",
		xmPushButtonWidgetClass,
		switchBBoard,
		args,
		argcnt);

    XtAddCallback(upperleftswitchPB, XmNactivateCallback, upperleftswitchPBHandler, (XtPointer)0);
    XtManageChild(upperleftswitchPB);

    return( retval );
}

